#!/bin/bash

if [ -z "$ENTRIES" ]; then
  echo ""; echo \
"Please set the location of your entries file. \
This can be done by issuing an \
'export ENTRIES=/path/to/entries.o' where \
'/path/to/' is the path to the entries file and \
entries.o is an Sasm compiled entries object file ( eg. 'ENTRIES.o' )."; echo "" && exit 1;
fi

export SENTRIES=`echo "$ENTRIES" | sed -E 's;/;\\/;g' -`

#echo "$SENTRIES"

sed -i -E "s;^SEARCH(\W)+.*$;SEARCH $SENTRIES;" math.m
rplcomp math.s math.a
sasm -v math.a
sload -H math.m

sed -i -E "s;^SEARCH(\W)+.*$;SEARCH $SENTRIES;" trig.m
rplcomp trig.s trig.a
sasm -v trig.a
sload -H trig.m
