ASSEMBLE
        NIBASC        /HPHP48-R/
        LIST
        LISTM
RPL

::

CODE

* Include unsupported entry point equates

    INCLUDE  unsuppentries.h

* Check and see if we have enough memory to push an extended real and a 16-digit hex string to the stack
* If not, generate an error exit.

    GOSUB    check_mem

    GOSBVL   =SAVPTR
    
********************************************************************************
** !!CAVEAT EMPTOR!!
**
** The following code disables interrupts so that the timer service routines 
** in the interrupt system don't screw up the 60 second countdown. Since this
** does not install an interrupt handler, if the calculator experiences a VLBI
** condition while this code is executing, you may get a TTRM. So, make sure
** that your batteries are fresh :)
**
********************************************************************************
    
    GOSBVL  =DisableIntr    * Abandon all hope ye who enter here...
    
    GOSUB   saveTimeandInit * Save system time and do some initialization
    
-   P=      11
    A=0     W
    LA(4)   #5626           * "Recall" 56.26 from "R0"
    B=A     W
    A=0     W
    P=      0
    LA(1)   #1
    
    GOSBVL  SINF            * Calculate extended 15-bit floating point value of y = sin(x) where x = "R0"
    GOSBVL  ASINF           * Calculate extended 15-bit floating point value of x = asin(y)
    GOSBVL  COSF            * Calculate extended 15-bit floating point value of y = cos(x)
    GOSBVL  ACOSF           * Calculate extended 15-bit floating point value of x = acos(y)
    GOSBVL  TANF            * Calculate extended 15-bit floating point value of y = tan(x)
    GOSBVL  ATANF           * Calculate extended 15-bit floating point value of x = atan(y)
    GOSBVL  LNF             * Calculate extended 15-bit floating point value of y = ln(x)
    GOSBVL  EXPF            * Calculate extended 15-bit floating point value of x = exp(y)
    
    SETHEX                  * Put us back into HEX mode

    C=R4                    * "Recall" "R2", increment it and save it
    C=C+1   W               *
    R4=C                    *

    D1=(5)  =TIMER2         * Read TIMER2 and see if it has underflowed. If so then
    P=  7                   * exit the loop.
    C=DAT1  WP              *
    C=C+C   P               *
    GOC end                 *

    SETDEC                  * 
    GONC    -               * Loop

    
end 

* Restore TIMER2 to what it should be, taking into account its current value
* and the time taken to execute the 60 second countdown

    GOSUB   restoreSysTime  

** Push the extended real result to the stack

    P=      0
    GOSBVL  PUSH%%          
    GOSBVL  =SAVPTR
** Re-enable interrupts
    GOSBVL  =AllowIntr

** Push value of "R2" as a hex string to the stack

    A=R4    
    P=      15
    GOVLNG  =PUSHhxsLoop    * We're done

    INCLUDE  common.a       * Include common assembly subroutine code

ENDCODE

    INCLUDE    common.s ( Include common Sys-RPL code )

;
